;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							
;							
;Uses first extra bit: YES				
;Clear: Face right
;Set: Face left
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite data		;
;;;;;;;;;;;;;;;;;;;;;;;;;

MARIO_SPEED		dcb $50,$B0
X_POS			dcb $10,$F0
X_POS_2			dcb $00,$FF

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			LDA $7FAB10,x
			AND #$04
			BEQ INIT_END
			INC $157C,x
INIT_END		RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			JSR SPRITE_GFX
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;Main sprite routine	;
;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN			RTS
SPRITE_ROUTINE		LDA $14C8,x
			CMP #$08
			BNE RETURN
			LDA $9D
			BNE RETURN
			JSR SUB_OFF_SCREEN_X0
			JSL $018032
			INC $1570,x

			LDA $167A,x
			PHA
			LDA $E4,x
			PHA
			LDA $14E0,x
			PHA

			JSL $01A7DC

			LDA #$81
			STA $167A,x
			LDY $157C,x
			LDA $E4,x
			CLC
			ADC X_POS,y
			STA $E4,x
			LDA $14E0,x
			ADC X_POS_2,y
			STA $14E0,x

			JSL $01A7DC
			BCC NOT_CONTACT
			LDY $157C,x
			LDA MARIO_SPEED,y
			STA $7B
			LDA #$D0
			STA $7D
			LDA #$01
			STA $1DF9

NOT_CONTACT		PLA
			STA $14E0,x
			PLA
			STA $E4,x
			PLA
			STA $167A,x

			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

TILE_MAP		dcb $C6,$E6
VERT_DISP		dcb $F0,$00
TILE_PROP		dcb $00,$40
HAND_TILE		= $C8
HAND_HORZ		dcb $0B,$0D,$12,$14
			dcb $0E,$10,$14,$14
			dcb $0B,$10,$13,$14
			dcb $0E,$10,$14,$14
HAND_VERT		dcb $FF,$F7,$02,$FB
			dcb $FC,$06,$F6,$00
			dcb $02,$F8,$07,$FD
			dcb $FC,$06,$F6,$00

SPRITE_GFX		JSR GET_DRAW_INFO

			LDA $1570,x
			LSR A
			LSR A
			AND #$03
			ASL A
			ASL A
			STA $03

			LDA $157C,x
			STA $02

			PHX
			LDX #$01
GFX_LOOP		PHX

			LDA $00
			STA $0300,y

			LDA $01
			CLC
			ADC VERT_DISP,x
			STA $0301,y

			LDA TILE_MAP,x
			STA $0302,y

			LDX $15E9
			LDA $15F6,x
			LDX $02
			ORA TILE_PROP,x
			ORA $64
			STA $0303,y
			STA $0F

			PLX
			INY
			INY
			INY
			INY
			DEX
			BPL GFX_LOOP

			LDX #$03
HAND_GFX_LOOP		PHX
			TXA
			CLC
			ADC $03
			TAX

			LDA $01
			CLC
			ADC HAND_VERT,x
			STA $0301,y

			LDA #HAND_TILE
			STA $0302,y

			LDA $0F
			ORA $64
			STA $0303,y

			LDA HAND_HORZ,x
			LDX $02
			BEQ NO_FLIP_HAND_H
			EOR #$FF
			INC A
NO_FLIP_HAND_H		CLC
			ADC $00
			STA $0300,y

			PLX
			INY
			INY
			INY
			INY
			DEX
			BPL HAND_GFX_LOOP
			PLX

			LDY #$02
			LDA #$05
			JSL $01B7B3
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1			dcb $0C,$1C
SPR_T2			dcb $01,$02

GET_DRAW_INFO		STZ $186C,x
			STZ $15A0,x
			LDA $E4,x
			CMP $1A
			LDA $14E0,x
			SBC $1B
			BEQ ON_SCREEN_X
			INC $15A0,x

ON_SCREEN_X		LDA $14E0,x
			XBA
			LDA $E4,x
			REP #$20
			SEC
			SBC $1A
			CLC
			ADC.W #$0040
			CMP.W #$0180
			SEP #$20
			ROL A
			AND #$01
			STA $15C4,x
			BNE INVALID

			LDY #$00
			LDA $1662,x
			AND #$20
			BEQ ON_SCREEN_LOOP
			INY
ON_SCREEN_LOOP		LDA $D8,x
			CLC
			ADC SPR_T1,y
			PHP
 			CMP $1C
			ROL $00
			PLP
			LDA $14D4,x
			ADC #$00
			LSR $00
			SBC $1D
			BEQ ON_SCREEN_Y
			LDA $186C,x
			ORA SPR_T2,y
			STA $186C,x
ON_SCREEN_Y		DEY
			BPL ON_SCREEN_LOOP

			LDY $15EA,x
			LDA $E4,x
			SEC
			SBC $1A
			STA $00
			LDA $D8,x
			SEC
			SBC $1C
			STA $01
			RTS

INVALID			PLA
			PLA
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12			dcb $40,$B0
SPR_T13			dcb $01,$FF
SPR_T14			dcb $30,$C0,$A0,$C0,$A0,$F0,$60,$90
			dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15			dcb $01,$FF,$01,$FF,$01,$FF,$01,$FF
			dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0	STZ $03

START_SUB		JSR SUB_IS_OFF_SCREEN
			BEQ RETURN_35
			LDA $5B
			AND #$01
			BNE VERTICAL_LEVEL
			LDA $D8,x
			CLC
			ADC #$50
			LDA $14D4,x
			ADC #$00
			CMP #$02
			BPL ERASE_SPRITE
			LDA $167A,x
			AND #$04
			BNE RETURN_35
			LDA $13
			AND #$01
			ORA $03
			STA $01
			TAY
  			LDA $1A
			CLC
			ADC SPR_T14,y
			ROL $00
			CMP $E4,x
			PHP
			LDA $1B
			LSR $00
			ADC SPR_T15,y
			PLP
			SBC $14E0,x
			STA $00
			LSR $01
			BCC SPR_L31
			EOR #$80
			STA $00
SPR_L31			LDA $00
			BPL RETURN_35
ERASE_SPRITE		LDA $14C8,x
			CMP #$08
			BCC KILL_SPRITE
			LDY $161A,x
			CPY #$FF
			BEQ KILL_SPRITE
			LDA #$00
			STA $1938,y
KILL_SPRITE		STZ $14C8,x
RETURN_35		RTS

VERTICAL_LEVEL		LDA $167A,x
			AND #$04
			BNE RETURN_35
			LDA $13
			LSR A
			BCS RETURN_35
			LDA $E4,x
			CMP #$00
			LDA $14E0,x
			SBC #$00
			CMP #$02
			BCS ERASE_SPRITE
			LDA $13
			LSR A
			AND #$01
			STA $01
			TAY
			LDA $1C
			CLC
			ADC SPR_T12,y
			ROL $00
			CMP $D8,x
			PHP
			LDA.W $001D
			LSR $00
			ADC SPR_T13,y
			PLP
			SBC $14D4,x
			STA $00
			LDY $01
			BEQ SPR_L38
			EOR #$80
  			STA $00
SPR_L38 		LDA $00
			BPL RETURN_35
			BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN	LDA $15A0,x
			ORA $186C,x
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sub horz pos		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDA $E4,x
			STA $00
			LDA $14E0,x
			STA $01
			REP #$20
			LDA $94
			SEC
			SBC $00
			STA $0E
			RTS